Attribute VB_Name = "Module1"
Option Explicit

Const vmax = 4, xmax = 4, ymax = 7, zmax = 4
Public v As Byte, x As Byte, y As Integer, z As Byte
Public grid(5, 5, 7, 5) As Byte
Public falling(5, 5, -5 To 7, 5) As Byte
Public temp(-vmax To vmax * 2, -xmax To xmax * 2, -ymax To ymax * 2, -zmax To zmax * 2) As Byte


Public Function Collision() As Boolean

Collision = False

For v = 0 To vmax
For x = 0 To xmax
For y = 0 To ymax
For z = 0 To zmax
    If grid(v, x, y, z) <> 0 And temp(v, x, y, z) <> 0 Then Collision = True
Next: Next: Next: Next

End Function

Public Function MoveFalling(dv As Integer, dx As Integer, dy As Integer, dz As Integer) As Boolean
Dim MaxV, MaxX, MaxY, MaxZ
Dim MinV, MinX, MinY, MinZ
MinV = vmax: MinX = xmax: MinY = ymax: MinZ = zmax
MaxV = 0: MaxX = 0: MaxY = 0: MaxZ = 0

MoveFalling = False

For v = 0 To vmax: For x = 0 To xmax: For y = 0 To ymax: For z = 0 To zmax
    If falling(v, x, y, z) <> 0 Then
       If MaxV < v Then MaxV = v
       If MaxX < x Then MaxX = x
       If MaxY < y Then MaxY = y
       If MaxZ < z Then MaxZ = z
       
       If MinV > v Then MinV = v
       If MinX > x Then MinX = x
       If MinY > y Then MinY = y
       If MinZ > z Then MinZ = z
    End If
Next: Next: Next: Next

If MaxV + dv > vmax Then Exit Function
If MaxX + dx > xmax Then Exit Function
If MaxY + dy > ymax Then Exit Function
If MaxZ + dz > zmax Then Exit Function
If MinV + dv < 0 Then Exit Function
If MinX + dx < 0 Then Exit Function
If MinZ + dz < 0 Then Exit Function

EmptyTemp
For v = 0 To vmax: For x = 0 To xmax: For y = -5 To ymax: For z = 0 To zmax
    temp(v + dv, x + dx, y + dy, z + dz) = falling(v, x, y, z)
Next: Next: Next: Next

For v = 0 To vmax: For x = 0 To xmax: For y = -5 To ymax: For z = 0 To zmax
    falling(v, x, y, z) = temp(v, x, y, z)
Next: Next: Next: Next

MoveFalling = True
End Function
Public Sub EmptyFalling()
For v = 0 To vmax: For x = 0 To xmax: For y = 0 To ymax: For z = 0 To zmax
    falling(v, x, y, z) = 0
Next: Next: Next: Next
End Sub
Public Sub EmptyTemp()
For v = 0 To vmax: For x = 0 To xmax: For y = 0 To ymax: For z = 0 To zmax
    temp(v, x, y, z) = 0
Next: Next: Next: Next
End Sub

Public Sub DrawGrid()
Dim index, color
For index = 0 To 24
    v = index Mod 5
    z = Int(index / 5)
    For x = 0 To xmax: For y = 0 To ymax
        color = grid(v, x, y, z)
        If falling(v, x, y, z) <> 0 Then color = falling(v, x, y, z) + 8
        Form1.picArea(index).Line (x, y)-(x + 1, y + 1), QBColor(color), BF
    Next: Next
    For x = 0 To xmax
        Form1.picArea(index).Line (x, 0)-(x, ymax), 0
    Next
    For y = 0 To ymax
        Form1.picArea(index).Line (0, y)-(xmax, y), 0
    Next
Next

End Sub

Public Sub FallingToGrid()
For v = 0 To vmax: For x = 0 To xmax: For y = 0 To ymax: For z = 0 To zmax
    If falling(v, x, y, z) <> 0 Then grid(v, x, y, z) = falling(v, x, y, z)
Next: Next: Next: Next
EmptyFalling
DrawGrid
End Sub
Public Sub newfalling()
falling(2, 2, -2, 2) = Int(Rnd * 5)
End Sub
